<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     Config.class.php
//      Version:   1.0.0
//      Datum:     29.01.2006
//      Author:    Martin Schiftan
//      Descr.:    Loads the config.inc.php and Languages Files and check them
//      license:   private
//
//////////////////////////////////////////////////////////////////////


function makelog($msg, $var=NULL)
  {
    global $n;
    $msg = str_replace('{HOLD}', $var, @$GLOBALS['languages'][$msg]);
    exit($n."\033[31mERROR:\033[0m".$n.$msg.$n);
  }




function warning($msg, $var=NULL)
  {
    global $n;
    $msg = @str_replace('{HOLD}', $var, @$GLOBALS['languages'][$msg]);
    echo $n."\033[33mWARNING:\033[0m".$n.$msg.$n;
  }




function ReplaceColors($msg)
  {
    $msg = str_replace('{BLACK}', "\033[30m", $msg);
    $msg = str_replace('{/BLACK}', "\033[0m", $msg);
    $msg = str_replace('{RED}', "\033[31m", $msg);
    $msg = str_replace('{/RED}', "\033[0m", $msg);
    $msg = str_replace('{GREEN}', "\033[32m", $msg);
    $msg = str_replace('{/GREEN}', "\033[0m", $msg);
    $msg = str_replace('{YELLOW}', "\033[33m", $msg);
    $msg = str_replace('{/YELLOW}', "\033[0m", $msg);
    $msg = str_replace('{BLUE}', "\033[34m", $msg);
    $msg = str_replace('{/BLUE}', "\033[0m", $msg);
    $msg = str_replace('{MAGENTA}', "\033[35m", $msg);
    $msg = str_replace('{/MAGENTA}', "\033[0m", $msg);
    $msg = str_replace('{CYAN}', "\033[36m", $msg);
    $msg = str_replace('{/CYAN}', "\033[0m", $msg);
    $msg = str_replace('{WHITE}', "\033[37m", $msg);
    $msg = str_replace('{/WHITE}', "\033[0m", $msg);
    return($msg);
  }




function ReplaceColorsOff($msg)
  {
    $msg = str_replace('{BLACK}', "", $msg);
    $msg = str_replace('{/BLACK}', "", $msg);
    $msg = str_replace('{RED}', "", $msg);
    $msg = str_replace('{/RED}', "", $msg);
    $msg = str_replace('{GREEN}', "", $msg);
    $msg = str_replace('{/GREEN}', "", $msg);
    $msg = str_replace('{YELLOW}', "", $msg);
    $msg = str_replace('{/YELLOW}', "", $msg);
    $msg = str_replace('{BLUE}', "", $msg);
    $msg = str_replace('{/BLUE}', "", $msg);
    $msg = str_replace('{MAGENTA}', "", $msg);
    $msg = str_replace('{/MAGENTA}', "", $msg);
    $msg = str_replace('{CYAN}', "", $msg);
    $msg = str_replace('{/CYAN}', "", $msg);
    $msg = str_replace('{WHITE}', "", $msg);
    $msg = str_replace('{/WHITE}', "", $msg);
    return($msg);
  }






class Config
  {
    public $configs;
    public $config;
    public $languages;
    public $home;
    public $langc;
    public $langb;

    public function __construct()
      {
        $configs['home'] = realpath(dirname(__FILE__).DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR;
        if(!file_exists($configs['home'].DIRECTORY_SEPARATOR.'config.inc.php'))
          {
            exit("\n\n".'ERROR: no config.inc.php found in : '.$configs['home']."\n\n");
          }
        require_once($configs['home'].'/config.inc.php');
        if((!isset($configs)) || (!is_array($configs)))
          {
            makelog('noconfig');
          }
        foreach($configs as $key => $value)
          {
            $value = preg_replace('/^off$/ium', 0, $value);
            $value = preg_replace('/^on$/ium', 1, $value);
            $configs[$key] = $value;
          }
        $this->configs        = $configs;
                                $this->LoadLanguages($configs['lang']);
        $return               = $this->CheckConfig();
        if(!file_exists($configs['home'].'log'))
          {
            mkdir($configs['home'].'log');
          }
        return($return);
      }





    public function GetConfig()
      {
         if((!isset($this->configs)) || (!is_array($this->configs)))
            {
              makelog('emptyconfig');
            }
          return($this->configs);
      }





    private function LoadLanguages($lang)
      {
        $this->languages = parse_ini_file($this->configs['home'].'languages/'.$lang.'.ini');
        if(!is_array($this->languages))
          {
            makelog('noloadlang', $this->configs['config']['home'].'/languages/'.$lang.'.ini');
          }
        foreach($this->languages as $key => $value)
          {
            if(php_sapi_name() != "cli")
              {
                $value = str_replace("\n", "<br />", $value);
              }
            $languagesc[$key] = ReplaceColors($value);
            $languagesb[$key] = ReplaceColorsOff($value);
          }
        $this->langc = $languagesc;
        $this->langb = $languagesb;
        return(1);
      }





    public function GetLanguages($color=NULL)
      {
        if(!isset($this->langb))
          {
            makelog('emptylanguage');
          }
        if($color == 1)
          {
            $this->languages = $this->langc;
          }
        else
          {
            $this->languages = $this->langb;
          }
        $GLOBALS['language'] = $this->languages;
        return($this->languages);
      }





    public function CheckConfig()
      {
        $return = 1;
        if((!isset($this->configs['key'])) || (strlen($this->configs['key']) != 10))
          {
            warning('keyfalse');
            $return = 0;
          }
        if((!isset($this->configs['lang'])) || (empty($this->configs['lang'])))
          {
            makelog('nolang');
            $return = 0;
          }
        if(version_compare(PHP_VERSION, '5.2.0', '<'))
          {
            makelog('phpversion', PHP_VERSION);
            $return = 0;
          }
        if(!isset($this->configs['createcronfile']))
          {
            $this->configs['createcronfile'] = 0;
          }
        if(!isset($this->configs['autoupdates']))
          {
            $this->configs['autoupdates'] = 1;
          }
        if(!isset($this->configs['timeout']))
          {
            $this->configs['timeout'] = 5;
          }
        if(!isset($this->configs['listnew']))
          {
            $this->configs['listnew'] = 0;
          }
        if(!isset($this->configs['format']))
          {
            $this->configs['format'] = 'text';
          }
        return($return);
      }





    public function GetMainVersion()
      {
        return($this->config['mainversion']);
      }





    public function UpdateVersion()
      {
        return($this->UpdateVersion);
      }
  }
