<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     updater.class.php
//      Version:   1.0.8
//      Datum:     16.01.2014
//      Author:    Martin Schiftan
//      Descr.:    Download Updates from the modules and php scripts and update them self
//      license:   private
//
//////////////////////////////////////////////////////////////////////


class Updater extends Run
  {
    public $error;
    public $checker;
    public $config;
    public $home;
    public $InstalledVersion;
    public $SetMainVersion;
    public $_REQUEST;


    public function __construct($config, $checker)
      {
        $this->error   = array();
        $this->checker = $checker;
        if((isset($config['createcronfile'])) && ($config['createcronfile'] != 1))
          {
            foreach($config['url'] as $key => $value)
              {
                $config['url'][$key] = str_replace('{$lang}', $config['lang'], $value);
              }
          }
        elseif((!isset($config['url'])) && ($config['createcronfile'] == 1) && (!file_exists($config['home'].'module/')))
          {
            $this->fehler('nomodules2');
            die();
          }
        $this->config = $config;
        $this->home   = $this->config['home'];
      }





    public function SelfUpdater()
      {
        $go = 0;
        $this->checker->config['oldmodulversion'] = $this->getCurrentVersion();
        if((isset($this->config['createcronfile'])) && ($this->config['createcronfile'] == 1) && (isset($_REQUEST['cronjob'])))
          {
            $this->InstalledVersion = $this->GetCurrentVersion();
            return(1);
          }
        if((isset($this->config['autoupdates'])) && ($this->config['autoupdates'] == 0))
          {
            $this->InstalledVersion = $this->GetCurrentVersion();
            $this->NewVersion       = $this->InstalledVersion;
            $this->MainVersion      = $this->config['mainversion'];
            $this->NewMainVersion   = $this->config['mainversion'];
            return(1);
          }




        # Main Files
        $this->checker->config['oldmainversion'] = $this->config['mainversion'];
        $newmainversion = $this->GetNewMainVersion();
        if((empty($newmainversion)) || (strlen($newmainversion) <= 0) || (stripos($newmainversion, 'ERROR') !== FALSE) || (stripos($newmainversion, 'via') !== FALSE))
          {
            $go = 0;
            if(!isset($this->error['newmainversionnr']))
              {
                $this->fehler('newmainversion', $newmainversion);
              }
            $this->checker->error['newmainversion'] = 1;
          }
        if(isset($this->checker->error['newmainversion']))
          {
            if(($this->config['ignoreupdate'] == 0) && ($newmainversion != $this->config['mainversion']))
              {
                $go = 1;
              }
            else
              {
                $go = 0;
              }
          }
        elseif($newmainversion != $this->config['mainversion'])
          {
            $go = 1;
          }
        if($go == 1)
          {
            $this->UpdateMainFiles();
            $this->checker->SetMainVersion($newmainversion);
            if($this->config['debug'] == 1)
              {
                $this->debug("MAIN FILES updated done....");
                $this->debug('TO ---> '.$newmainversion);
                $this->debug("RE-RUN again with same params......");
              }
            elseif(isset($_REQUEST['man']))
              {
                echo "MAIN FILES updated done....\n";
                echo 'TO ---> '.$newmainversion;
                echo "\nRE-RUN again with same params......\n\n";
              }

            unset($_REQUEST[0]);
            $_REQUEST[1] = $_REQUEST["path"];
            if(!function_exists('pcntl_exec'))
              {
                  function pcntl_exec($path,$args=array())
                    {
                        if(is_string($args)) $args = array($args);
                        if(count($args)) $path = '"'.$path.'"';
                        $shell = new COM('WScript.Shell');
                        $shell->run($path.(count($args) ? ' '.implode(' ',$args) : ''),0,true);
                    }
              }
            elseif(function_exists('pcntl_exec'))
              {
                pcntl_exec($_SERVER['SCRIPT_NAME'], $_REQUEST);
              }
            else
              {
                $this->fehler('updatedmainfile', $newmainversion);
              }
          }
        else
          {
             $this->checker->SetMainVersion = $newmainversion;
          }




        # Modules
        $this->InstalledVersion = $this->GetCurrentVersion();
        $newversion             = $this->GetNewUpdateVersion();
        if((!is_numeric($newversion)) || ($newversion < 1))
          {
            if(!isset($this->error['newversionnr']))
              {
                $this->fehler('newversionnr', $newversion);
              }
            $this->error['newversionnr'] = 1;
          }
        if(($newversion != $this->InstalledVersion) || (isset($_REQUEST['forceupdate'])))
          {
            if(isset($_REQUEST['forceupdate']))
              {
                $this->InstalledVersion = 00000;
              }
            $this->UpdateVersion = $this->UpdateModules();
            $this->GetCurrentVersion();
          }

        return(1);
      }




    public function GetCurrentVersion()
      {
        if(stripos(ini_get('disable_functions'), 'file_get_contents') === FALSE)
          {
            $this->InstalledVersion = intval(@file_get_contents($this->home.'updateversion.txt'));
          }
        else
          {
            $fp = @file($this->home.'updateversion.txt');
            $this->InstalledVersion = intval($fp[0]);
          }
        $modules         = new ModulesClasses();
        $modules->config = $this->config;
        $modules->home   = $this->home;
        if($modules->GetModulesCount() <= 0)
          {
             $this->InstalledVersion = 00;
          }
        if((!isset($this->InstalledVersion)) || ($this->InstalledVersion < 0))
          {
            $this->InstalledVersion = '000';
          }
        return($this->InstalledVersion);
      }


    public function windows_rename_fix(string $oldName, string $newName, $context = null): bool
      {
        $didCopy = copy($oldName, $newName, $context);
        if(!$didCopy)
          {
            return false;
          }
        @unlink($oldName, $context);
        return true;
     }




    public function UpdateModules()
      {
        if((!isset($this->home)) || (empty($this->home)) || (str_replace('/classes', '/', str_replace('\classes', '\\', dirname(__FILE__))) != $this->home))
          {
            $this->fehler('homenotset', $this->home.', '.__FILE__.' -> '.__LINE__);
            die(1);
          }
        if(file_exists($this->home.'updates.tar.gz'))
          {
            @unlink($this->home.'updates.tar.gz');
            @unlink($this->home.'updates.tar.gz.md5');
          }
        $newmd5     = $this->GetFile($this->config['url']['updatesmd5'], 'updates.tar.gz.md5');
        $newtar     = $this->GetFile($this->config['url']['updates'], 'updates.tar.gz');
        if(stripos(@$newtar, 'error') !== FALSE)
          {
            if((!isset($this->InstalledVersion)) || (empty($this->InstalledVersion)))
              {
                $this->InstalledVersion = 0;
              }
            $this->UpdateVersion  = $this->InstalledVersion;
            $this->WriteNewVersion($this->UpdateVersion);
            $this->fehler('novaliduser', $newtar);
            $this->checker->error['newversionnr'] = 1;
            return($this->UpdateVersion);
          }
        elseif(file_exists($this->home.'updates.tar.gz'))
          {
            if(md5_file($this->home.'updates.tar.gz') !== $newmd5)
              {
                              @unlink($this->home.'updates.tar.gz');
                              @unlink($this->home.'updates.tar.gz.md5');
                $newmd5     = $this->GetFile($this->config['url']['updatesmd5'], 'updates.tar.gz.md5');
                $newmd5     = trim($newmd5);
                $newtar     = $this->GetFile($this->config['url']['updates'], 'updates.tar.gz');
                if(md5_file($this->home.'updates.tar.gz') !== $newmd5)
                  {
                    @unlink($this->home.'updates.tar.gz');
                    @unlink($this->home.'updates.tar.gz.md5');
                    makelog('updates.tar.gz.md5', $newmd5);
                  }
              }
            if(file_exists($this->home.'module'))
              {
                if(file_exists($this->home.'module.bak'))
                  {
                    $this->delTree($this->home.'module.bak');
                    @unlink($this->home.'module.bak');
                  }
                rename($this->home.'module', $this->home.'module.bak');
              }
             $zip = new PharData($this->home.'updates.tar.gz');
                    $zip->extractTo($this->home.DIRECTORY_SEPARATOR, NULL, true);
            @unlink($this->home.'updates.tar.gz');
            @unlink($this->home.'updates.tar.gz.md5');
            $this->WriteNewVersion(@$this->UpdateVersion);
            if((file_exists($this->home.'module.bak')) && (file_exists($this->home.'module')))
              {
                $this->delTree($this->home.'module.bak');
                @unlink($this->home.'module.bak');
              }
            elseif(!file_exists($this->home.'module'))
              {
                if(!isset($this->InstalledVersion))
                  {
                    $this->InstalledVersion = $this->GetCurrentVersion();
                  }
                rename($this->home.'module.bak', $this->home.'module');
                $this->WriteNewVersion($this->InstalledVersion);
                @unlink($this->home.'updates.tar.gz');
                @unlink($this->home.'updates.tar.gz.md5');
                return(@$this->InsalledVersion);
              }
          }
        else
          {
            if(!isset($this->InstalledVersion))
              {
                $this->InstalledVersion = $this->GetCurrentVersion();
              }
            $this->WriteNewVersion($this->InstalledVersion);
            $this->fehler('newmainversion', $newtar);
            $this->checker->error['newversionnr'] = 1;
            return($this->InstalledVersion);
          }
        return(@$this->UpdateVersion);
      }


      public function delTree($dir)
        {
          $files = array_diff(scandir($dir), array('.','..'));
          foreach($files as $file)
            {
              (is_dir("$dir/$file")) ? $this->delTree("$dir/$file") : unlink("$dir/$file");
            }
          return rmdir($dir);
        }



    private function WriteNewVersion($newversion)
      {
        if(!isset($newversion))
          {
            $newversion = $this->InstalledVersion;
          }
        $fp = fopen($this->home.'updateversion.txt', 'w+');
        @fputs($fp, @$newversion);
        fclose($fp);
        return(1);
      }





    public function GetFile($url, $user=NULL)
      {
        $get = new FileStuff($this);
        if((isset($user)) && ($user !== NULL))
          {
            $data = array('key' => $this->config['key']);
            $get->SetPostData($data);
          }
        $data = $get->GetRemoteData($url);
        return($data);
      }





    private function GetNewUpdateVersion()
      {
        $newversion = $this->GetFile($this->config['url']['version'], $this->config);
        $newversion = str_replace("\n", '', $newversion);
        $isint      = str_replace('.', '', $newversion);
        if((empty($newversion)) || (!is_numeric($isint)))
          {
            if(!isset($this->error['newversionnr']))
              {
                $this->fehler('newversionnr', $newversion);
              }
            $this->error['newversionnr'] = 1;
            $newversion = $this->GetCurrentVersion();
          }
        else
          {
            $this->UpdateVersion = $newversion;
          }
        return($newversion);
      }





    public function UpdateMainFiles()
      {
        if((!isset($this->home)) || (empty($this->home)) || (str_replace('/classes', '/', str_replace('\classes', '\\', dirname(__FILE__))) != $this->home))
          {
            $this->fehler('homenotset', $this->home.', '.__FILE__.' -> '.__LINE__);
            die(1);
          }
        $update = @unlink($this->home.'latest.tar.gz');
        $update = @unlink($this->home.'latest.tar.gz.md5');
        $newtar = $this->GetFile($this->config['url']['mainupdate'], 'latest.tar.gz');
        $newmd5 = $this->GetFile($this->config['url']['mainupdate5'], 'latest.tar.gz.md5');
        $newmd5 = trim($newmd5);
        if(stripos($newtar, 'error') !== FALSE)
          {
            makelog('novaliduser', $newtar);
          }
        if(file_exists($this->home.'latest.tar.gz'))
          {
            if(md5_file($this->home.'latest.tar.gz') !== $newmd5)
              {
                makelog('latest.tar.gz.md5', $newmd5);
              }
             $zip = new PharData($this->home.'latest.tar.gz');
                    $zip->extractTo($this->home.DIRECTORY_SEPARATOR, NULL, true);
          }
        elseif(!file_exists($this->home.'latest.tar.gz'))
          {
            if((!isset($this->checker->error['newmainversionnr'])) && ($this->config['ignoreupdate'] == 0))
              {
                $this->fehler('newmainversiondownload', $update);
              }
            $newmainversion = $this->config['mainversion'];
          }
        $update = @unlink($this->home.'latest.tar.gz');
        $update = @unlink($this->home.'latest.tar.gz.md5');
#        @shell_exec('rm -rf '.$this->home.'latest.tar.gz');
        return(1);
      }





    private function GetNewMainVersion()
      {
        $newmainversion = $this->GetFile($this->config['url']['mainversion'], $this->config);
        $newmainversion = str_replace("\n", '', $newmainversion);
        if(empty($newmainversion))
          {
            if((!isset($this->error['newmainversionnr'])) && ($this->config['ignoreupdate'] == 0))
              {
                $this->fehler('newmainversion');
              }
            $this->error['newmainversionnr'] = 1;
            $newmainversion = $this->config['mainversion'];
          }
        return($newmainversion);
      }
  }




