#!/usr/bin/env  php
<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more)
//      Datei:     main.php
//      Version:   see $config['mainversion']
//      Datum:     21.02.2009
//      Author:    Martin Schiftan
//      Descr.:    Prueft im angegebenen Verzeichnis ob veraltete Web-Applicationen gefunden wurden und ob diese aktuell sind
//      license:   GNU Public License (Update der Versionsnummer/Module kostenpflichtig)
//
//////////////////////////////////////////////////////////////////////
error_reporting(E_ALL);
ini_set('display_errors', 'on');
ini_set('max_execution_time', 0);
ini_set('memory_limit', '50000M');
@date_default_timezone_set(date_default_timezone_get());
$config['home']               = dirname(__FILE__).DIRECTORY_SEPARATOR;
$config['mainversion']        = '0.0.4';
$config['ignoreupdate']       = 0;
$config['createcronfile']     = 1;
$config['ignoreupdate']       = 0;
$starttime                    = time();
if(!defined('STDIN'))
  {
    define('STDIN', fopen("php://stdin", "r"));
  }

if(!file_exists($config['home'].'classes/Checker.class.php'))
  {
    exit("\nERROR: File classes/Checker.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Checker.class.php';
if(!file_exists($config['home'].'classes/Config.class.php'))
  {
    exit("\nERROR: File classes/Config.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Config.class.php';
if(!file_exists($config['home'].'classes/Filestuff.class.php'))
  {
    exit("\nERROR: File classes/Filestuff.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Filestuff.class.php';
if(!file_exists($config['home'].'classes/Updater.class.php'))
  {
    exit("\nERROR: File classes/Updater.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Updater.class.php';
if(!file_exists($config['home'].'classes/ModulesClasses.class.php'))
  {
    exit("\nERROR: File classes/ModulesClasses.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/ModulesClasses.class.php';



ob_implicit_flush(true);
@ob_end_flush();
register_shutdown_function('shutdown');


$main = new Run($config, 1);
$main->SetHome($config['home']);


$phpmodul    = php_sapi_name();
if($phpmodul == 'cli')
  {
# argv
    if((isset($argv[1])) && (!empty($argv[1])))
      {
        $argv['pfad'] = $_REQUEST['pfad'] = $argv[1];
      }
    $_REQUEST = $argv;
    foreach($argv as $key => $value)
      {
        if(stripos($value, '='))
          {
            $vals               = explode('=', $value);
            $_REQUEST[$vals[0]] = $vals[1];
          }
        else
          {
            if((!isset($value)) || (empty($value)))
              {
                $_REQUEST[$key] = $key;
              }
            elseif((is_numeric($key)) && (!empty($value)))
              {
                $_REQUEST[$value] = $value;
              }
          }
      }
  }
elseif(stripos($phpmodul, 'cgi') !== FALSE)
  {
# request
    if((isset($_REQUEST[2])) && (!empty($_REQUEST[2])))
      {
        $_REQUEST['pfad'] = $_REQUEST[2];
      }
    foreach($_REQUEST as $key => $value)
      {
        if(!isset($_REQUEST['pfad']))
          {
            $_REQUEST['pfad'] = $key;
          }
        if(stripos($value, '='))
          {
            $vals               = explode('=', $value);
            $_REQUEST[$vals[0]] = $vals[1];
          }
        else
          {
            if((!isset($value)) || (empty($value)))
              {
                $_REQUEST[$key]   = $key;
              }
            elseif((is_numeric($key)) && (!empty($value)))
              {
                $_REQUEST[$value] = $value;
              }
          }
      }
  }


$languages = $main->GetLanguages($main->config['color']);
$header    = $languages['header'];


if((isset($_REQUEST['help'])) || (isset($_REQUEST['--help'])) || (isset($_REQUEST['-h'])) || (isset($_REQUEST['--h'])))
  {
    $output  = $languages['helpcreatecronjob'];
    $output .= ' '.$languages['listversion']."\n";
    $output .= "\n ".$languages['modulversion']."            ".$main->GetModulesVersion();
    $output .= "\n ".$languages['mainversion']."              ".$main->GetMainVersion();
    $output .= "\n ".$languages['searchcounts']."    ".$main->GetCountModules()."\n\n\n";
    echo $output;
    exit(0);
  }



if((!isset($_REQUEST['pfad'])) || (empty($_REQUEST['pfad'])))
  {
    $main->pfad = $_SERVER['PWD'];
  }
elseif((isset($_REQUEST['pfad'])) && (!empty($_REQUEST['pfad'])))
  {
    $main->pfad = $_REQUEST['pfad'];
  }

if(substr($main->pfad, 0, 1) == '.')
  {
    $main->pfad = $_SERVER['PWD'].DIRECTORY_SEPARATOR.$main->pfad;
  }
if(substr($main->pfad, -1) != DIRECTORY_SEPARATOR)
  {
    $main->pfad .= DIRECTORY_SEPARATOR;
  }
if(!is_dir($main->pfad))
  {
    $main->fehler('dirnotfound', $main->pfad);
  }



if($main->GetCountModules() <= 0)
  {
    $main->fehler('nomodules');
    die();
  }



$header    = str_replace('{COUNTMODULE}', $main->GetCountModules(), $header);
$header    = str_replace('{SUCHPFAD}', $main->pfad, $header);
$header    = str_replace('{DATUM}', date('Y-m-d H:i:s O'), $header);
$header    = @str_replace('{BLACKLIST}', @$_REQUEST['blacklist'], $header);
$header    = str_replace('{HOLD}', $main->pfad, $header);

$footer = $languages['footer'];

# Started Programm with all required variables
echo $languages['started'];
flush();

$main->GetModules();
if(isset($_REQUEST['modul']))
  {
    $modul = strtolower($_REQUEST['modul']);
    if(!in_array($modul, $main->GetModulesNames()))
      {
        $main->fehler('searchmodulnotexists', $modul);
      }
  }
elseif((isset($argv[3])) && ($argv[3] != 'cronjob') && (stripos($argv[2], 'blacklist') !== FALSE) && (stripos($argv[3], 'blacklist') !== FALSE))
  {
    $modul = strtolower($argv[3]);
    if(!in_array($modul, $main->GetModulesNames()))
      {
        $main->fehler('searchmodulnotexists', $modul);
      }
  }
else
  {
    $modul = NULL;
  }






$cronjobfile = $config['home'].'cronjobfiles'.DIRECTORY_SEPARATOR;

if(!file_exists($cronjobfile))
  {
    mkdir($cronjobfile);
  }
$filenames       = str_replace(DIRECTORY_SEPARATOR, '_', str_replace('\\', '_', $main->pfad));
$cronjobsavefile = preg_replace('/[^a-zA-Z0-9_]/', '', $filenames);
$cronjobsavefile = $cronjobfile.$cronjobsavefile;

if(file_exists($cronjobsavefile))
  {
    if((!isset($config['cronjoboverride'])) || ($config['cronjoboverride'] != 1))
      {
        $line = NULL;
        while(1)
          {
            $line = strtolower($line);
            if(($line != 'y') && ($line != 'j'))
              {
                echo str_replace('{HOLD}', date('d.m.Y H:i:s O', filemtime($cronjobsavefile)), $languages['cronjobfileoverride']);
                $line = strtolower(trim(str_replace("\n", '', fgets(STDIN))));
                if(($line == '') || (empty($line)) || (strlen($line) == 0) || ($line == 'y') || ($line == 'j'))
                  {
                    $line = 'y';
                    echo "\nYES: ".$languages['cronjobfileoverridetrue']."\n\n";
                    break;
                  }
                if($line == 'n')
                  {
                    die("\n".'NO: '.$languages['cronjobexit']."\n\n");
                  }
              }
            elseif($line == 'n')
              {
                die("\n".'NO: '.$languages['cronjobexit']."\n\n");
              }
          }
      }
    else
      {
        unlink($cronjobsavefile);
      }
  }

$files = $main->GetFilesList($modul);
$count = $main->GetNumFiles();

$text = '# CronJob File for OutdatedSoftware
# generated: '.date('d.m.Y H:i:s O').'
# UpdateVersion: '.$main->GetModulesVersion().'
# counts: '.@$count.'
'.implode("\n", $files);



$fp = fopen($cronjobsavefile, 'w+');
fputs($fp, $text);
fclose($fp);

$header    = str_replace('{COUNTMODULE}', $main->GetCountModules(), $header);
$header    = str_replace('{SUCHPFAD}', $main->pfad, $header);
$header    = str_replace('{MAINVERSION}', $main->GetMainVersion(), $header);
$header    = str_replace('{UPDATEDVERSION}', $main->GetModulesVersion(), $header);
$header    = str_replace('{DATUM}', date('Y-m-d H:i:s O'), $header);
$header    = @str_replace('{BLACKLIST}', @$_REQUEST['blacklist'], $header);
$header    = str_replace('{FUNDE}', $count.' Version-Files to check', $header);
if(@$module == NULL)
  {
    $modul = $languages['searchmodul'];
  }
$header    = str_replace('{SUCHMODULE}', $modul, $header);

$footer = str_replace('{UPTODATE}', '', $footer);
$footer = str_replace('{FUNDE}', $count.' Version-Files to check', $footer);
$footer = str_replace('{ALL}', $count, $footer);
$header = str_replace('{UPTODATE}', '', $header);
$minus  = time() - $starttime;
$footer = str_replace('{ENDE}', date('Y-m-d H:i:s O').' ('.$minus.' Seconds)', $footer);


echo $header;
echo $languages['cronjobfilesaved']."\n".$cronjobsavefile."\n\n";
echo str_replace('\n', "\n", str_replace('{HOLD}', $main->pfad, $languages['remebertodelete']))."\n\n";
echo $footer;



function shutdown()
  {
    if((isset($main->pid)) && ($main->pid >= 100))
      {
        shell_exec('kill -9 '.$main->pid);
        @unlink($main->findfile);
      }
  }

@unlink($main->findfile);
@shell_exec('find '.$main->home.'log/ -mtime +3 -and -type f -exec rm -fr {} \;');
